]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: activate virtualenv in a subshell
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
75       if [ "$SHELL" = /bin/bash ]; then
76          if [ -f /etc/bash_completion ]; then
77             . /etc/bash_completion
78          elif [ -d /etc/bash_completion.d ]; then
79             . /etc/bash_completion.d/*
80          fi
81       elif [ "$SHELL" = /usr/local/bin/bash ]; then
82          if [ -d /usr/local/etc/bash_completion.d ]; then
83             . /usr/local/etc/bash_completion.d/*
84          fi
85       else
86          echo "Unknown OS type, cannot source bash_completion" >&2
87       fi
88    fi
89
90    has_completion() { return 0; }
91    if [ "$SHELL" = /bin/bash ]; then
92       if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
93          has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
94       fi
95    elif [ "$SHELL" = /usr/local/bin/bash ]; then
96       if [ -d /usr/local/etc/bash_completion.d ]; then
97          has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
98       fi
99    fi
100
101    for cmd in builtin cgmem_nice command dbus-launch exec \
102       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
103       time whence whereis which xargs; do
104          ! has_completion $cmd && complete -o default -A command $cmd
105    done
106
107    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
108       telnet t tt \
109       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
110       whois wget wget-m wget-wrapper ww; do
111          ! has_completion $cmd && complete -A hostname $cmd
112    done
113
114    for cmd in distribute ftp lftp r rsync \
115       s scp ssh smbclient tcpdump tshark wireshark; do
116          ! has_completion $cmd && complete -o default -A hostname $cmd;
117    done
118
119    delegate_completion() {
120       local prog programs
121       prog=$1
122       if has_completion $prog; then
123          shift
124          programs="$@"
125          eval "_${prog}_completion_loader() {
126             _completion_loader $prog
127             complete -F _$prog $programs
128             unset _${prog}_completion_loader
129             return 124
130          }"
131          complete -F _${prog}_completion_loader $programs
132       fi
133    }
134
135    delegate_completion make m
136    delegate_completion ping p
137    delegate_completion rsync r
138    delegate_completion ssh s
139    delegate_completion wget wget-m wget-wrapper ww
140
141    unset has_completion delegate_completion
142
143    complete -A job bg fg j jobs wait
144    complete -A variable -A function unset
145
146    if [ -d "$HOME/lib/config" ]; then
147       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
148    fi
149    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
150
151    #if type -p pip >/dev/null 2>&1; then
152    #   eval "`pip completion --bash`"
153    #   rm -rf /tmp/pip_build_"$USER"
154    #fi
155
156    #if which pyenv >/dev/null 2>&1; then
157    #   eval "`pyenv init -`"
158    #   eval "`pyenv virtualenv-init -`"
159    #fi
160
161    source virtualenvwrapper_lazy.sh 2>/dev/null
162
163    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
164       . "$VIRTUAL_ENV/bin/activate"
165    fi
166
167 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
168    back() { cd - "$@"; }
169    j() { jobs; }
170 fi
171
172
173 # clear screen and history, logout
174 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
175
176
177 if test -x /usr/bin/git >/dev/null 2>&1; then
178    # chdir to a remote's directory (if the remote is on the local FS)
179    cdremote() {
180       if [ -z "$1" -o -n "$2" ]; then
181          echo "Usage: cdremote remote_name" >&2
182          return 1
183       fi
184       cd "`git config --get remote.$1.url`"
185    }
186
187    if test -n "$BASH_VERSION"; then
188       # completion for aliases in global .gitconfig
189
190       # fixup rbi rbia rbiap rbip - do refs name completion
191       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
192       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
193       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
194       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
195       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
196       #
197       # push-to-all-remotes - do branch name completion
198       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
199
200       # list remotes with URLs matching a regexp
201       _list_remotes() {
202          if [ -z "$1" -o -n "$2" ]; then
203             echo "Usage: _list_remotes remote_regexp" >&2
204             return 1
205          fi
206          GIT_REMOTES=""
207          local remote
208          for remote in `git remote`; do
209             if git config --get remote.$remote.url | grep -q "$1"; then
210                GIT_REMOTES="$GIT_REMOTES $remote"
211             fi
212          done
213       }
214
215       # completion for cdremote and git-open - list remotes with a pattern
216       _list_remotes_completion() {
217          local cur="${COMP_WORDS[COMP_CWORD]}";
218          _list_remotes "$1"
219          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
220          unset GIT_REMOTES
221       }
222
223       # completion for cdremote - list remotes with directories as URLs
224       _cdremote_complete() {
225          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
226       }
227
228       complete -F _cdremote_complete cdremote
229
230       # completion for git-open - list remotes with http(s) URLs
231       _git_open() {
232          _list_remotes_completion '^http\(s\)\?://'
233       }
234
235       complete -F _git_open git-open
236    fi
237 fi
238
239
240 include() {
241    cfg="$1"
242    if [ -f "./$cfg" -a -r "./$cfg" ]; then
243       echo "Reading config file \`$cfg'" 1>&2
244       . "./$cfg"
245    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
246       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
247       . "$HOME/lib/config/$cfg"
248    else
249       echo "Cannot find config file \`$cfg'" 1>&2
250    fi
251 }
252
253
254 mc() {
255    if test -n "$BASH_VERSION"; then
256       MC_SAVE_OPS1="$OPS1"
257       OPS1="\u@\h "
258    fi
259
260    if [ -n "$SLOWTERM" ]; then
261       MC_SLOW="--slow"
262    fi
263
264    case "$TERM" in
265       screen*) # screen, screen.rxvt
266          if [ "$TERM" = screen.rxvt ]; then
267             MC_SAVE_TERM="$TERM"
268             TERM=rxvt
269          fi
270          MC_XTERM="-x"
271       ;;
272    esac
273
274    #TMPDIR="$HOME"/tmp
275    #export TMPDIR
276
277    MC_FOUND=NO
278
279    for wrapper in \
280          /usr/local/share/mc/bin/mc-wrapper.sh \
281          /usr/local/libexec/mc/mc-wrapper.sh \
282          /usr/share/mc/bin/mc-wrapper.sh; do
283       if [ -r $wrapper ]; then
284          . $wrapper $MC_SLOW $MC_XTERM "$@"
285          rc=$?
286          MC_FOUND=YES
287          break
288       fi
289    done
290
291    if [ $MC_FOUND = NO ]; then
292       for mc in /usr/local/bin/mc /usr/bin/mc; do
293          if [ -x $mc ]; then
294             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
295             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
296                MC_TMP_DIR="${TMPDIR-/tmp}"
297             fi
298             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
299             mc_type="`mc_type.py $mc`"
300             if [ "$mc_type" = old ]; then
301                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
302             elif [ "$mc_type" = new ]; then
303                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
304             else
305                continue
306             fi
307             rc=$?
308             MC_FOUND=YES
309             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
310             break
311          fi
312       done
313    fi
314
315    if [ $MC_FOUND = NO ]; then
316       echo "Cannot find mc-wrapper.sh or mc" >&2
317       rc=1
318    fi
319
320    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
321    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
322    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
323          MC_SLOW MC_TMP_DIR MC_XTERM
324
325    return $rc
326 }
327
328
329 mkcd() {
330    if [ $# -ne 1 ]; then
331       echo "Usage: mkcd directory_name" >&2
332    elif [ -d "$1" ]; then
333       cd "$1"
334    elif [ -e "$1" ]; then
335       echo "Error: $1 is a file" >&2
336    else
337       mkdir -p "$1" && cd "$1"
338    fi
339 }
340
341
342 if which tmux >/dev/null 2>&1; then
343    tmux() {
344       case "$TERM" in
345          rxvt)
346             TERM=rxvt-unicode command tmux "$@"
347          ;;
348
349          *)
350             command tmux "$@"
351          ;;
352       esac
353    }
354 fi
355
356
357 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
358    X() { startx >> .Xserver.log 2>&1; cyr; }
359 fi
360
361 x() { exit; }